DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Text Area

The JavaScript TextArea component enables users to enter and edit multi-line text. This component can have a fixed or resizable height. The component with the fixed height displays a native scroll bar if the entered text exceeds the text area. If you set the autoResizeEnabled property to true, the JavaScript TextArea automatically resizes its height to fit the text.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the TextArea features used.
Backend API
$(() => { const exampleTextArea = $('#example-textarea').dxTextArea({ value: longText, height: 90, inputAttr: { 'aria-label': 'Notes' }, }).dxTextArea('instance'); $('#set-max-length').dxCheckBox({ value: false, onValueChanged(data) { const str = data.value ? exampleTextArea.option('value').substring(0, 100) : longText; exampleTextArea.option('value', str); exampleTextArea.option('maxLength', data.value ? 100 : null); }, text: 'Limit text length', }); $('#set-resize').dxCheckBox({ value: false, onValueChanged(e) { exampleTextArea.option('autoResizeEnabled', e.value); exampleTextArea.option('height', e.value ? undefined : 90); }, text: 'Enable auto resize', }); const valueChangeEvents = [{ title: 'On Change', name: 'change', }, { title: 'On Key Up', name: 'keyup', }]; $('#change-event').dxSelectBox({ items: valueChangeEvents, inputAttr: { 'aria-label': 'Event' }, value: valueChangeEvents[0].name, valueExpr: 'name', displayExpr: 'title', onValueChanged(data) { editingTextArea.option('valueChangeEvent', data.value); }, }); const editingTextArea = $('#editing-textarea').dxTextArea({ value: longText, height: 90, valueChangeEvent: 'change', inputAttr: { 'aria-label': 'Notes' }, onValueChanged(data) { disabledTextArea.option('value', data.value); }, }).dxTextArea('instance'); const disabledTextArea = $('#disabled-textarea').dxTextArea({ value: longText, height: 90, readOnly: true, inputAttr: { 'aria-label': 'Notes' }, }).dxTextArea('instance'); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.6"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="dx-fieldset"> <div class="dx-fieldset-header">Default Mode</div> <div class="dx-field"> <div id="set-max-length"></div> </div> <div class="dx-field"> <div id="set-resize"></div> </div> </div> <div class="textarea-wrapper"> <div id="example-textarea"></div> </div> <div class="full-width-content"> <div class="dx-fieldset"> <div class="dx-fieldset-header">Event Handling and API</div> <div class="dx-field"> <div class="dx-field-label">Synchronize text areas </div> <div class="dx-field-value"> <div id="change-event"></div> </div> </div> </div> <div class="textarea-wrapper"> <div id="editing-textarea"></div> <div id="disabled-textarea"></div> </div> </div> </div> </body> </html>
.full-width-content { width: 100%; margin-top: 30px; } .full-width-content .textarea-wrapper > .dx-widget { margin-bottom: 20px; } .full-width-content .dx-field { max-width: 385px; } .textarea-wrapper { padding: 0 20px; }
const longText = 'Prepare 2013 Marketing Plan: We need to double revenues in 2013 and our marketing strategy is going to be key here. R&D is improving existing products and creating new products so we can deliver great AV equipment to our customers.Robert, please make certain to create a PowerPoint presentation for the members of the executive team.';

You can also specify the maxLength property to limit the number of characters a user can enter. Note that this property only limits the number of characters for users. You can enter text that exceeds the maximum character length programmatically, but the number of characters displayed to users will still be limited by this property setting.

The JavaScript TextArea stores the text in the value property and updates it after the DOM event occurs. To specify which DOM event to use instead of the default "change" event, use the valueChangeEvent property. To handle the value change, use the JavaScript TextArea's onValueChanged function.

Change the text in the Event Handling and API section below to see how this feature works. Use the "Synchronize text areas" drop-down menu to select which event updates the read-only component's value: "change" or "keyup".

<template>
<div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Default Mode</div>
<div class="dx-field">
<DxCheckBox
:value="false"
text="Limit text length"
@value-changed="onCheckboxValueChanged"
/>
</div>
<div class="dx-field">
<DxCheckBox
v-model:value="autoResizeEnabled"
text="Enable auto resize"
@value-changed="onAutoResizeChanged"
/>
</div>
</div>
<div class="textarea-wrapper">
<DxTextArea
v-model:height="height"
:max-length="maxLength"
:input-attr="{ 'aria-label': 'Notes' }"
v-model:value="value"
v-model:auto-resize-enabled="autoResizeEnabled"
/>
</div>
<div class="full-width-content">
<div class="dx-fieldset">
<div class="dx-fieldset-header">Event Handling and API</div>
<div class="dx-field">
<div class="dx-field-label">Synchronize text areas </div>
<div class="dx-field-value">
<DxSelectBox
:items="valueChangeEvents"
v-model:value="eventValue"
:input-attr="{ 'aria-label': 'Event' }"
value-expr="name"
display-expr="title"
/>
</div>
</div>
</div>
<div class="textarea-wrapper">
<DxTextArea
:height="90"
:input-attr="{ 'aria-label': 'Notes' }"
v-model:value="valueForEditableTextArea"
:value-change-event="eventValue"
/>
<DxTextArea
:height="90"
:read-only="true"
:value="valueForEditableTextArea"
:input-attr="{ 'aria-label': 'Notes' }"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxTextArea from 'devextreme-vue/text-area';
import DxCheckBox, { type DxCheckBoxTypes } from 'devextreme-vue/check-box';
import DxSelectBox from 'devextreme-vue/select-box';
import service from './data.ts';
const eventValue = ref(service.valueChangeEvents[0].name);
const maxLength = ref<number>();
const value = ref(service.getContent());
const valueForEditableTextArea = ref(service.getContent());
const valueChangeEvents = service.valueChangeEvents;
const autoResizeEnabled = ref(false);
const height = ref<number | undefined>(90);
function onCheckboxValueChanged(e: DxCheckBoxTypes.ValueChangedEvent) {
const str = service.getContent();
value.value = e.value ? str.substring(0, 100) : str;
maxLength.value = e.value ? 100 : undefined;
}
function onAutoResizeChanged(e: DxCheckBoxTypes.ValueChangedEvent) {
height.value = e.value ? undefined : 90;
}
</script>
<style>
.full-width-content {
width: 100%;
margin-top: 30px;
}
.full-width-content .textarea-wrapper > .dx-widget {
margin-bottom: 20px;
}
.full-width-content .dx-field {
max-width: 385px;
}
.textarea-wrapper {
padding: 0 20px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
const valueChangeEvents = [{
title: 'On Change',
name: 'change',
}, {
title: 'On Key Up',
name: 'keyup',
}];
const content = 'Prepare 2013 Marketing Plan: We need to double revenues in 2013 and our marketing strategy is going to be key here. R&D is improving existing products and creating new products so we can deliver great AV equipment to our customers.Robert, please make certain to create a PowerPoint presentation for the members of the executive team.';
export default {
valueChangeEvents,
getContent() {
return content;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

import React, { useCallback, useState } from 'react';
import CheckBox from 'devextreme-react/check-box';
import type { CheckBoxTypes } from 'devextreme-react/check-box';
import SelectBox from 'devextreme-react/select-box';
import type { SelectBoxTypes } from 'devextreme-react/select-box';
import TextArea from 'devextreme-react/text-area';
import type { TextAreaTypes } from 'devextreme-react/text-area';
import { valueChangeEvents, content } from './data.ts';
const notesLabel = { 'aria-label': 'Notes' };
const eventLabel = { 'aria-label': 'Event' };
function App() {
const [value, setValue] = useState<string>(content);
const [valueForEditableTestArea, setValueForEditableTestArea] = useState<string>(content);
const [maxLength, setMaxLength] = useState<number | undefined>(undefined);
const [eventValue, setEventValue] = useState<string>(valueChangeEvents[0].name);
const [autoResizeEnabled, setAutoResizeEnabled] = useState<boolean>(false);
const [height, setHeight] = useState<number | undefined>(90);
const onCheckboxValueChanged = useCallback((e: CheckBoxTypes.ValueChangedEvent): void => {
const str = content;
setValue(e.value ? str.substring(0, 100) : str);
setMaxLength(e.value ? 100 : undefined);
}, []);
const onAutoResizeChanged = useCallback((e: CheckBoxTypes.ValueChangedEvent): void => {
setAutoResizeEnabled(e.value);
setHeight(e.value ? undefined : 90);
}, []);
const onSelectBoxValueChanged = useCallback((e: SelectBoxTypes.ValueChangedEvent): void => {
setEventValue(e.value);
}, []);
const onTextAreaValueChanged = useCallback((e: TextAreaTypes.ValueChangedEvent): void => {
setValueForEditableTestArea(e.value);
}, []);
return (
<>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Default Mode</div>
<div className="dx-field">
<CheckBox
defaultValue={false}
onValueChanged={onCheckboxValueChanged}
text="Limit text length"
></CheckBox>
</div>
<div className="dx-field">
<CheckBox
value={autoResizeEnabled}
onValueChanged={onAutoResizeChanged}
text="Enable auto resize"
></CheckBox>
</div>
</div>
<div className="textarea-wrapper">
<TextArea
height={height}
maxLength={maxLength}
defaultValue={value}
inputAttr={notesLabel}
autoResizeEnabled={autoResizeEnabled}
/>
</div>
<div className="full-width-content">
<div className="dx-fieldset">
<div className="dx-fieldset-header">Event Handling and API</div>
<div className="dx-field">
<div className="dx-field-label">Synchronize text areas </div>
<div className="dx-field-value">
<SelectBox
items={valueChangeEvents}
valueExpr="name"
displayExpr="title"
inputAttr={eventLabel}
value={eventValue}
onValueChanged={onSelectBoxValueChanged}
/>
</div>
</div>
</div>
<div className="textarea-wrapper">
<TextArea
height={90}
value={valueForEditableTestArea}
valueChangeEvent={eventValue}
inputAttr={notesLabel}
onValueChanged={onTextAreaValueChanged}
/>
<TextArea
height={90}
value={valueForEditableTestArea}
readOnly={true}
inputAttr={notesLabel}
valueChangeEvent={eventValue}
/>
</div>
</div>
</>
);
}
export default App;
import React, { useCallback, useState } from 'react';
import CheckBox from 'devextreme-react/check-box';
import SelectBox from 'devextreme-react/select-box';
import TextArea from 'devextreme-react/text-area';
import { valueChangeEvents, content } from './data.js';
const notesLabel = { 'aria-label': 'Notes' };
const eventLabel = { 'aria-label': 'Event' };
function App() {
const [value, setValue] = useState(content);
const [valueForEditableTestArea, setValueForEditableTestArea] = useState(content);
const [maxLength, setMaxLength] = useState(undefined);
const [eventValue, setEventValue] = useState(valueChangeEvents[0].name);
const [autoResizeEnabled, setAutoResizeEnabled] = useState(false);
const [height, setHeight] = useState(90);
const onCheckboxValueChanged = useCallback((e) => {
const str = content;
setValue(e.value ? str.substring(0, 100) : str);
setMaxLength(e.value ? 100 : undefined);
}, []);
const onAutoResizeChanged = useCallback((e) => {
setAutoResizeEnabled(e.value);
setHeight(e.value ? undefined : 90);
}, []);
const onSelectBoxValueChanged = useCallback((e) => {
setEventValue(e.value);
}, []);
const onTextAreaValueChanged = useCallback((e) => {
setValueForEditableTestArea(e.value);
}, []);
return (
<>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Default Mode</div>
<div className="dx-field">
<CheckBox
defaultValue={false}
onValueChanged={onCheckboxValueChanged}
text="Limit text length"
></CheckBox>
</div>
<div className="dx-field">
<CheckBox
value={autoResizeEnabled}
onValueChanged={onAutoResizeChanged}
text="Enable auto resize"
></CheckBox>
</div>
</div>
<div className="textarea-wrapper">
<TextArea
height={height}
maxLength={maxLength}
defaultValue={value}
inputAttr={notesLabel}
autoResizeEnabled={autoResizeEnabled}
/>
</div>
<div className="full-width-content">
<div className="dx-fieldset">
<div className="dx-fieldset-header">Event Handling and API</div>
<div className="dx-field">
<div className="dx-field-label">Synchronize text areas </div>
<div className="dx-field-value">
<SelectBox
items={valueChangeEvents}
valueExpr="name"
displayExpr="title"
inputAttr={eventLabel}
value={eventValue}
onValueChanged={onSelectBoxValueChanged}
/>
</div>
</div>
</div>
<div className="textarea-wrapper">
<TextArea
height={90}
value={valueForEditableTestArea}
valueChangeEvent={eventValue}
inputAttr={notesLabel}
onValueChanged={onTextAreaValueChanged}
/>
<TextArea
height={90}
value={valueForEditableTestArea}
readOnly={true}
inputAttr={notesLabel}
valueChangeEvent={eventValue}
/>
</div>
</div>
</>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(<App />, document.getElementById('app'));
import type { ValueChangeEvent } from './types.ts';
export const valueChangeEvents: ValueChangeEvent[] = [{
title: 'On Change',
name: 'change',
}, {
title: 'On Key Up',
name: 'keyup',
}];
export const content = 'Prepare 2013 Marketing Plan: We need to double revenues in 2013 and our marketing strategy is going to be key here. R&D is improving existing products and creating new products so we can deliver great AV equipment to our customers.Robert, please make certain to create a PowerPoint presentation for the members of the executive team.';
export type ValueChangeEvent = {
title: string;
name: string;
};
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const valueChangeEvents = [
{
title: 'On Change',
name: 'change',
},
{
title: 'On Key Up',
name: 'keyup',
},
];
export const content =
'Prepare 2013 Marketing Plan: We need to double revenues in 2013 and our marketing strategy is going to be key here. R&D is improving existing products and creating new products so we can deliver great AV equipment to our customers.Robert, please make certain to create a PowerPoint presentation for the members of the executive team.';
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.full-width-content {
width: 100%;
margin-top: 30px;
}
.full-width-content .textarea-wrapper > .dx-widget {
margin-bottom: 20px;
}
.full-width-content .dx-field {
max-width: 385px;
}
.textarea-wrapper {
padding: 0 20px;
}

<div class="dx-fieldset">
<div class="dx-fieldset-header">Default Mode</div>
<div class="dx-field">
<dx-check-box
[value]="false"
(onValueChanged)="onCheckboxValueChanged($event)"
text="Limit text length"
>
</dx-check-box>
</div>
<div class="dx-field">
<dx-check-box
[(value)]="autoResizeEnabled"
(onValueChanged)="onAutoResizeChanged($event)"
text="Enable auto resize"
></dx-check-box>
</div>
</div>
<div class="textarea-wrapper">
<dx-text-area
[(height)]="height"
[maxLength]="maxLength"
[(value)]="value"
[(autoResizeEnabled)]="autoResizeEnabled"
[inputAttr]="{ 'aria-label': 'Notes' }"
>
</dx-text-area>
</div>
<div class="full-width-content">
<div class="dx-fieldset">
<div class="dx-fieldset-header">Event Handling and API</div>
<div class="dx-field">
<div class="dx-field-label">Synchronize text areas </div>
<div class="dx-field-value">
<dx-select-box
[items]="valueChangeEvents"
valueExpr="name"
[inputAttr]="{ 'aria-label': 'Event' }"
displayExpr="title"
[(value)]="eventValue"
>
</dx-select-box>
</div>
</div>
</div>
<div class="textarea-wrapper">
<dx-text-area
[height]="90"
[(value)]="valueForEditableTextArea"
[valueChangeEvent]="eventValue"
[inputAttr]="{ 'aria-label': 'Notes' }"
>
</dx-text-area>
<dx-text-area
[height]="90"
[readOnly]="true"
[(value)]="valueForEditableTextArea"
[inputAttr]="{ 'aria-label': 'Notes' }"
>
</dx-text-area>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxTextAreaModule, DxCheckBoxModule, DxSelectBoxModule } from 'devextreme-angular';
import { DxCheckBoxTypes } from 'devextreme-angular/ui/check-box';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxTextAreaModule,
DxCheckBoxModule,
DxSelectBoxModule,
],
})
export class AppComponent {
valueChangeEvents = [{
title: 'On Change',
name: 'change',
}, {
title: 'On Key Up',
name: 'keyup',
}];
eventValue: string;
maxLength = null;
value: string;
valueForEditableTextArea: string;
height = 90;
autoResizeEnabled: boolean;
constructor(private service: Service) {
this.valueForEditableTextArea = this.service.getContent();
this.value = this.service.getContent();
this.eventValue = this.valueChangeEvents[0].name;
this.autoResizeEnabled = false;
}
onCheckboxValueChanged({ value }: DxCheckBoxTypes.ValueChangedEvent) {
const str = this.service.getContent();
this.value = value ? str.substring(0, 100) : str;
this.maxLength = value ? 100 : null;
}
onAutoResizeChanged({ value }: DxCheckBoxTypes.ValueChangedEvent) {
this.height = value ? undefined : 90;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .full-width-content {
width: 100%;
margin-top: 30px;
}
::ng-deep .full-width-content .textarea-wrapper > .dx-widget {
margin-bottom: 20px;
}
::ng-deep .full-width-content .dx-field {
max-width: 385px;
}
::ng-deep .textarea-wrapper {
padding: 0 20px;
}
import { Injectable } from '@angular/core';
const content = 'Prepare 2013 Marketing Plan: We need to double revenues in 2013 and our marketing strategy is going to be key here. R&D is improving existing products and creating new products so we can deliver great AV equipment to our customers.Robert, please make certain to create a PowerPoint presentation for the members of the executive team.';
@Injectable()
export class Service {
getContent() {
return content;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.8"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>